MODULE caldyn_vars_mod
  USE icosa
  USE transfert_mod
  IMPLICIT NONE
  PUBLIC
  SAVE

  INTEGER, PARAMETER :: conserv_energy=1, conserv_enstrophy=2, &
       kinetic_trisk=1, kinetic_consistent=2, &
       caldyn_vert_noncons=1, caldyn_vert_cons=2, &
       thermo_none=-99, thermo_theta=1, thermo_entropy=2, &
       thermo_moist=3, thermo_boussinesq=4, thermo_dry=10, thermo_fake_moist=11, thermo_moist_debug=100

  INTEGER :: caldyn_conserv, caldyn_kinetic, caldyn_thermo, caldyn_vert_variant, physics_thermo
  !$OMP THREADPRIVATE(caldyn_conserv, caldyn_kinetic, caldyn_thermo, caldyn_vert_variant, physics_thermo)

  LOGICAL :: boussinesq, hydrostatic
  !$OMP THREADPRIVATE(boussinesq, hydrostatic)

  LOGICAL :: dysl, dysl_geopot, dysl_pvort_only, dysl_caldyn_fast, dysl_caldyn_coriolis, dysl_slow_hydro, dysl_caldyn_vert
  !$OMP THREADPRIVATE(dysl, dysl_geopot, dysl_pvort_only, dysl_caldyn_fast, dysl_caldyn_coriolis, dysl_slow_hydro, dysl_caldyn_vert)

  ! temporary shared variables for caldyn
  TYPE(t_field),POINTER :: f_qu(:), f_qv(:), f_Kv(:), &
                           f_pk(:),f_wwuu(:),f_planetvel(:), &
                           f_Fel(:), f_gradPhi2(:), f_wil(:), f_Wetadot(:)

  TYPE(t_message) :: req_ps, req_mass, req_theta_rhodz, req_u, req_qu, req_geopot, req_w

END MODULE caldyn_vars_mod
